<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\AboutRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\Abouts;
use App\AboutDescriptions;
use App\Language;
use App\Module;
use Users_model;

class AboutController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/abouts';
    /** View folder */
    private $viewDirectory= 'admin.abouts.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('abouts.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the abouts.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query =Abouts::orderBy('id', 'ASC');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->key) {
            $query->where('id', aboutkeydescription($request->key));
        }
        if ($request->value) {
            $query->where('id', aboutvaluedescription($request->value));
        }

        if ($request->lang) {
            $query->whereIn('language_id', currentLanguageid($request->lang) );
        }

      

        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $abouts= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('abouts'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('abouts.store');
        $head = metaFields('abouts', 'add_new', getCurrentLocale()) ?? __('abouts.new');
        $language = Language::where('status',1)->get();

        return view( $this->viewDirectory.'form', compact('action', 'head','language') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param AboutRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(AboutRequest $request) :RedirectResponse
    {
        $about = Abouts::create($request->all());
        foreach ($request->about as $key => $row) {
            
           AboutDescriptions::create([
               'key'=>$row['key'],
               'value'=>$row['value'],
               'about_id'=>$about->id,
               'language_id'=>$row['language_id'],
               ]);
        }
        

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  Idea  $idea
     * @return View
     */
    public function edit(Abouts $about): View
    {
        $action= route('abouts.update', $about->id);
        $head = metaFields('abouts', 'edit', getCurrentLocale()) ?? __('abouts.edit');
        $language = Language::where('status',1)->get();

        return view( $this->viewDirectory.'form', compact( 'about','action', 'head' ,'language' ) );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  AboutRequest  $request
     * @param  Idea  $idea
     * @return RedirectResponse|Redirector
     */
    public function update(AboutRequest $request, Abouts $about) :RedirectResponse
    {
        $about->update(['image'=>$request->image]);
        
        AboutDescriptions::where('about_id',$about->id)->forceDelete();
        foreach ($request->about as $key => $row) {
            
           AboutDescriptions::create([
               'key'=>$row['key'],
               'value'=>$row['value'],
               'about_id'=>$about->id,
               'language_id'=>$row['language_id'],
               ]);
        }
        

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $idea = Abouts::withTrashed()->find($id);
        if ($idea) {
            if ($idea->deleted_at) {
                $idea->forceDelete();
            } else {
                $idea->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Abouts::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Abouts::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $idea = Abouts::withTrashed()->find($id);

        if ($idea){
            $idea->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $idea = Abouts::whereIn('id', $request->ids)->onlyTrashed();
        if ($idea){
            $idea->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
